<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: Vector3D.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_vector3_d_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Vector3D.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_vector3_d_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#ifndef VECTOR3D_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define VECTOR3D_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;stddef.h&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_vector2_d_8h.html">Vector2D.h</a>&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">class </span>RotationMatrix;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">class </span>Quaternion;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_vector3_d.html">   29</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a> {</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;  <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a4434fbd95b0f760a7f374d8068238c87">Vector3D</a>(T <a class="code" href="classflair_1_1core_1_1_vector3_d.html#abb356ca2add4d7cd62c3e1772ce84a4f">x</a> = 0, T <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a62a7b867d542c4aee7634f8a58b25256">y</a> = 0, T <a class="code" href="classflair_1_1core_1_1_vector3_d.html#ab0c47253b9de56abf0fbe9661f9e1812">z</a> = 0);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;  <a class="code" href="classflair_1_1core_1_1_vector3_d.html#ae09b7edbe9f6be35b9f171eefd401b99">~Vector3D</a>();</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_vector3_d.html#abb356ca2add4d7cd62c3e1772ce84a4f">   51</a></span>&#160;  T <a class="code" href="classflair_1_1core_1_1_vector3_d.html#abb356ca2add4d7cd62c3e1772ce84a4f">x</a>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_vector3_d.html#a62a7b867d542c4aee7634f8a58b25256">   56</a></span>&#160;  T <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a62a7b867d542c4aee7634f8a58b25256">y</a>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_vector3_d.html#ab0c47253b9de56abf0fbe9661f9e1812">   61</a></span>&#160;  T <a class="code" href="classflair_1_1core_1_1_vector3_d.html#ab0c47253b9de56abf0fbe9661f9e1812">z</a>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a195e8601b80e5e85a4d361c5a9b746a0">RotateX</a>(<span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a70eb14b1c286020f1e5a092a6188b361">RotateXDeg</a>(<span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a47b3902a89379a918cd9f5441aa7c748">RotateY</a>(<span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a57a22e954ffffa6f9c8d828788ac1eac">RotateYDeg</a>(<span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#aaa82d7a6693e70ff7b242aceb977e9c0">RotateZ</a>(<span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a3cd28096c5b268d44fae64ff3de97c60">RotateZDeg</a>(<span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a5b55225f9547b97a21758c1e2b65dea3">Rotate</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_rotation_matrix.html">RotationMatrix</a> &amp;matrix);</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a5b55225f9547b97a21758c1e2b65dea3">Rotate</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;quaternion);</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#af7bca23dab226f26818cddcac3771b0e">To2Dxy</a>(<a class="code" href="classflair_1_1core_1_1_vector2_d.html">Vector2D&lt;T&gt;</a> &amp;vector) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;  <a class="code" href="classflair_1_1core_1_1_vector2_d.html">Vector2D&lt;T&gt;</a> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#af7bca23dab226f26818cddcac3771b0e">To2Dxy</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;  <span class="keywordtype">float</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a4249aef85a1848a2952dfafbe6caad12">GetNorm</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a8230b1bbc50b49afac2758e44bcbb02c">Normalize</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a82a85beea28856be5b64f1d773ecebec">Saturate</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;T&gt;</a> &amp;min, <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;T&gt;</a> &amp;max);</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a82a85beea28856be5b64f1d773ecebec">Saturate</a>(<span class="keywordtype">float</span> min, <span class="keywordtype">float</span> max);</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a82a85beea28856be5b64f1d773ecebec">Saturate</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;T&gt;</a> &amp;value);</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html#a82a85beea28856be5b64f1d773ecebec">Saturate</a>(<span class="keywordtype">float</span> value);</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;  T &amp;operator[](<span class="keywordtype">size_t</span> idx);</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;  <span class="keyword">const</span> T &amp;operator[](<span class="keywordtype">size_t</span> idx) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;  <span class="comment">//Vector3D&lt;T&gt; &amp;operator=(const Vector3D&lt;T&gt; &amp;vector);</span></div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;  <span class="keyword">template</span>&lt;<span class="keyword">typename</span> S&gt; <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;T&gt;</a> &amp;operator=(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;S&gt;</a> &amp;vector) {</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    x = vector.<a class="code" href="classflair_1_1core_1_1_vector3_d.html#abb356ca2add4d7cd62c3e1772ce84a4f">x</a>;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    y = vector.<a class="code" href="classflair_1_1core_1_1_vector3_d.html#a62a7b867d542c4aee7634f8a58b25256">y</a>;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    z = vector.<a class="code" href="classflair_1_1core_1_1_vector3_d.html#ab0c47253b9de56abf0fbe9661f9e1812">z</a>;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    <span class="keywordflow">return</span> (*<span class="keyword">this</span>);</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;  }</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;  <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;T&gt;</a> &amp;operator+=(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;T&gt;</a> &amp;vector);</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;  <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;T&gt;</a> &amp;operator-=(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_vector3_d.html">Vector3D&lt;T&gt;</a> &amp;vector);</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;};</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="keyword">typedef</span> Vector3D&lt;float&gt; Vector3Df;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; Vector3D&lt;T&gt; <a class="code" href="namespaceflair_1_1core.html#ab372a1107820a30d6fcbef13c8989caa">operator+</a>(<span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorA, <span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorB);</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; Vector3D&lt;T&gt; <a class="code" href="namespaceflair_1_1core.html#ac696d4111ec3b0241bc094add5666245">operator-</a>(<span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorA, <span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorB);</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; Vector3D&lt;T&gt; <a class="code" href="namespaceflair_1_1core.html#ac696d4111ec3b0241bc094add5666245">operator-</a>(<span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vector);</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; Vector3D&lt;T&gt; <a class="code" href="namespaceflair_1_1core.html#afed3cf9fa6c2e0afb37994f55222d019">operator/</a>(<span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vector, <span class="keywordtype">float</span> coeff);</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; Vector3D&lt;T&gt; <a class="code" href="namespaceflair_1_1core.html#a7a25a222fe16e05be703de31123a6d11">operator*</a>(<span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorA, <span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorB);</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; Vector3D&lt;T&gt; <a class="code" href="namespaceflair_1_1core.html#a7a25a222fe16e05be703de31123a6d11">operator*</a>(<span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vector, <span class="keywordtype">float</span> coeff);</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; Vector3D&lt;T&gt; <a class="code" href="namespaceflair_1_1core.html#a7a25a222fe16e05be703de31123a6d11">operator*</a>(<span class="keywordtype">float</span> coeff, <span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vector);</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; Vector3D&lt;T&gt; <a class="code" href="namespaceflair_1_1core.html#a619733e606845eb59f7e779f2f119019">CrossProduct</a>(<span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorA, <span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorB);</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keywordtype">float</span> <a class="code" href="namespaceflair_1_1core.html#a792d54dcdbd816e6c7bc5ac04b5d9b22">DotProduct</a>(<span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorA, <span class="keyword">const</span> Vector3D&lt;T&gt; &amp;vectorB);</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;} <span class="comment">// end namespace core</span></div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;<span class="preprocessor">#endif // VECTOR3D_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a8230b1bbc50b49afac2758e44bcbb02c"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a8230b1bbc50b49afac2758e44bcbb02c">flair::core::Vector3D::Normalize</a></div><div class="ttdeci">void Normalize(void)</div><div class="ttdoc">Normalize. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a57a22e954ffffa6f9c8d828788ac1eac"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a57a22e954ffffa6f9c8d828788ac1eac">flair::core::Vector3D::RotateYDeg</a></div><div class="ttdeci">void RotateYDeg(float value)</div><div class="ttdoc">y axis rotation </div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_aaa82d7a6693e70ff7b242aceb977e9c0"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#aaa82d7a6693e70ff7b242aceb977e9c0">flair::core::Vector3D::RotateZ</a></div><div class="ttdeci">void RotateZ(float value)</div><div class="ttdoc">z axis rotation </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a></div><div class="ttdoc">Class defining a 3D vector. </div><div class="ttdef"><b>Definition:</b> Vector3D.h:29</div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector2_d_html"><div class="ttname"><a href="classflair_1_1core_1_1_vector2_d.html">flair::core::Vector2D</a></div><div class="ttdoc">Class defining a 2D vector. </div><div class="ttdef"><b>Definition:</b> Vector2D.h:24</div></div>
<div class="ttc" id="classflair_1_1core_1_1_rotation_matrix_html"><div class="ttname"><a href="classflair_1_1core_1_1_rotation_matrix.html">flair::core::RotationMatrix</a></div><div class="ttdoc">Class defining a rotation matrix. </div><div class="ttdef"><b>Definition:</b> RotationMatrix.h:26</div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_ae09b7edbe9f6be35b9f171eefd401b99"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#ae09b7edbe9f6be35b9f171eefd401b99">flair::core::Vector3D::~Vector3D</a></div><div class="ttdeci">~Vector3D()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a3cd28096c5b268d44fae64ff3de97c60"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a3cd28096c5b268d44fae64ff3de97c60">flair::core::Vector3D::RotateZDeg</a></div><div class="ttdeci">void RotateZDeg(float value)</div><div class="ttdoc">z axis rotation </div></div>
<div class="ttc" id="_vector2_d_8h_html"><div class="ttname"><a href="_vector2_d_8h.html">Vector2D.h</a></div><div class="ttdoc">Class defining a 2D vector. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a82a85beea28856be5b64f1d773ecebec"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a82a85beea28856be5b64f1d773ecebec">flair::core::Vector3D::Saturate</a></div><div class="ttdeci">void Saturate(const Vector3D&lt; T &gt; &amp;min, const Vector3D&lt; T &gt; &amp;max)</div><div class="ttdoc">Saturate. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a62a7b867d542c4aee7634f8a58b25256"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a62a7b867d542c4aee7634f8a58b25256">flair::core::Vector3D::y</a></div><div class="ttdeci">T y</div><div class="ttdoc">y </div><div class="ttdef"><b>Definition:</b> Vector3D.h:56</div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_af7bca23dab226f26818cddcac3771b0e"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#af7bca23dab226f26818cddcac3771b0e">flair::core::Vector3D::To2Dxy</a></div><div class="ttdeci">Vector2D&lt; T &gt; To2Dxy(void) const </div><div class="ttdoc">Convert to a Vector2D. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a47b3902a89379a918cd9f5441aa7c748"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a47b3902a89379a918cd9f5441aa7c748">flair::core::Vector3D::RotateY</a></div><div class="ttdeci">void RotateY(float value)</div><div class="ttdoc">y axis rotation </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a5b55225f9547b97a21758c1e2b65dea3"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a5b55225f9547b97a21758c1e2b65dea3">flair::core::Vector3D::Rotate</a></div><div class="ttdeci">void Rotate(const RotationMatrix &amp;matrix)</div><div class="ttdoc">rotation </div></div>
<div class="ttc" id="namespaceflair_1_1core_html_afed3cf9fa6c2e0afb37994f55222d019"><div class="ttname"><a href="namespaceflair_1_1core.html#afed3cf9fa6c2e0afb37994f55222d019">flair::core::operator/</a></div><div class="ttdeci">Vector2D&lt; T &gt; operator/(const Vector2D&lt; T &gt; &amp;vector, float coeff)</div><div class="ttdoc">Divid. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a70eb14b1c286020f1e5a092a6188b361"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a70eb14b1c286020f1e5a092a6188b361">flair::core::Vector3D::RotateXDeg</a></div><div class="ttdeci">void RotateXDeg(float value)</div><div class="ttdoc">x axis rotation </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_ab0c47253b9de56abf0fbe9661f9e1812"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#ab0c47253b9de56abf0fbe9661f9e1812">flair::core::Vector3D::z</a></div><div class="ttdeci">T z</div><div class="ttdoc">z </div><div class="ttdef"><b>Definition:</b> Vector3D.h:61</div></div>
<div class="ttc" id="namespaceflair_1_1core_html_a7a25a222fe16e05be703de31123a6d11"><div class="ttname"><a href="namespaceflair_1_1core.html#a7a25a222fe16e05be703de31123a6d11">flair::core::operator*</a></div><div class="ttdeci">Quaternion operator*(Quaternion const &amp;quaternionA, Quaternion const &amp;quaterniontB)</div><div class="ttdoc">Multiply. </div></div>
<div class="ttc" id="namespaceflair_1_1core_html_ac696d4111ec3b0241bc094add5666245"><div class="ttname"><a href="namespaceflair_1_1core.html#ac696d4111ec3b0241bc094add5666245">flair::core::operator-</a></div><div class="ttdeci">Quaternion operator-(Quaternion const &amp;quaternionA, Quaternion const &amp;quaterniontB)</div><div class="ttdoc">Substract. </div></div>
<div class="ttc" id="namespaceflair_1_1core_html_a792d54dcdbd816e6c7bc5ac04b5d9b22"><div class="ttname"><a href="namespaceflair_1_1core.html#a792d54dcdbd816e6c7bc5ac04b5d9b22">flair::core::DotProduct</a></div><div class="ttdeci">float DotProduct(const Vector3D&lt; T &gt; &amp;vectorA, const Vector3D&lt; T &gt; &amp;vectorB)</div><div class="ttdoc">Dot product. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_abb356ca2add4d7cd62c3e1772ce84a4f"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#abb356ca2add4d7cd62c3e1772ce84a4f">flair::core::Vector3D::x</a></div><div class="ttdeci">T x</div><div class="ttdoc">x </div><div class="ttdef"><b>Definition:</b> Vector3D.h:51</div></div>
<div class="ttc" id="namespaceflair_1_1core_html_a619733e606845eb59f7e779f2f119019"><div class="ttname"><a href="namespaceflair_1_1core.html#a619733e606845eb59f7e779f2f119019">flair::core::CrossProduct</a></div><div class="ttdeci">Vector3D&lt; T &gt; CrossProduct(const Vector3D&lt; T &gt; &amp;vectorA, const Vector3D&lt; T &gt; &amp;vectorB)</div><div class="ttdoc">Cross product. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a4249aef85a1848a2952dfafbe6caad12"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a4249aef85a1848a2952dfafbe6caad12">flair::core::Vector3D::GetNorm</a></div><div class="ttdeci">float GetNorm(void) const </div><div class="ttdoc">Norm. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a4434fbd95b0f760a7f374d8068238c87"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a4434fbd95b0f760a7f374d8068238c87">flair::core::Vector3D::Vector3D</a></div><div class="ttdeci">Vector3D(T x=0, T y=0, T z=0)</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_vector3_d_html_a195e8601b80e5e85a4d361c5a9b746a0"><div class="ttname"><a href="classflair_1_1core_1_1_vector3_d.html#a195e8601b80e5e85a4d361c5a9b746a0">flair::core::Vector3D::RotateX</a></div><div class="ttdeci">void RotateX(float value)</div><div class="ttdoc">x axis rotation </div></div>
<div class="ttc" id="namespaceflair_1_1core_html_ab372a1107820a30d6fcbef13c8989caa"><div class="ttname"><a href="namespaceflair_1_1core.html#ab372a1107820a30d6fcbef13c8989caa">flair::core::operator+</a></div><div class="ttdeci">Quaternion operator+(Quaternion const &amp;quaterniontA, Quaternion const &amp;quaterniontB)</div><div class="ttdoc">Add. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_quaternion_html"><div class="ttname"><a href="classflair_1_1core_1_1_quaternion.html">flair::core::Quaternion</a></div><div class="ttdoc">Class defining a quaternion. </div><div class="ttdef"><b>Definition:</b> Quaternion.h:26</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_97265977dbbd48c696782ccac102bad5.html">FlairCore</a></li><li class="navelem"><a class="el" href="dir_6c198461db290ac9abcdd44184573216.html">src</a></li><li class="navelem"><a class="el" href="_vector3_d_8h.html">Vector3D.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
